"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.prefixedLogger = exports.basicLogger = void 0;
exports.basicLogger = {
    debug(message, meta) {
        console.debug("[DEBUG]", message, meta);
    },
    error(message, error, meta) {
        console.error("[ERROR]", message, error, meta);
    },
    info(message, meta) {
        console.info("[INFO]", message, meta);
    }
};
const prefixedLogger = (prefix) => ({
    debug(message, meta) {
        console.debug(`[${prefix}][DEBUG]`, message, meta);
    },
    error(message, error, meta) {
        console.error(`[${prefix}][ERROR]`, message, error, meta);
    },
    info(message, meta) {
        console.info(`[${prefix}][INFO]`, message, meta);
    }
});
exports.prefixedLogger = prefixedLogger;
