import { AxiosPromise, AxiosRequestConfig } from "axios";
import { CreateChatCompletionRequest, CreateCompletionRequest } from "openai/api";
import { CreateChatCompletionResponse, CreateCompletionResponse, CreateEmbeddingRequest, CreateEmbeddingResponse, OpenAIApi } from "openai";
export interface IOpenAIClient {
    createCompletion(createCompletionRequest: CreateCompletionRequest, options?: AxiosRequestConfig): AxiosPromise<CreateCompletionResponse>;
    createChatCompletion(createChatCompletionRequest: CreateChatCompletionRequest, options?: AxiosRequestConfig): AxiosPromise<CreateChatCompletionResponse>;
    createStreamingChatCompletion(createChatCompletionRequest: CreateChatCompletionRequest, options?: AxiosRequestConfig): AxiosPromise<CreateChatCompletionResponse>;
    performEmbedding(createEmbeddingRequest: CreateEmbeddingRequest, options?: AxiosRequestConfig): AxiosPromise<CreateEmbeddingResponse>;
    performModeration(userRequest: string): Promise<IsFlagged>;
}
type IsFlagged = boolean;
export declare class OpenAIClient implements IOpenAIClient {
    private openAIApi;
    constructor(openAIApi: OpenAIApi);
    performEmbedding(createEmbeddingRequest: CreateEmbeddingRequest, options?: AxiosRequestConfig): AxiosPromise<CreateEmbeddingResponse>;
    performModeration(userRequest: string): Promise<IsFlagged>;
    createCompletion(createCompletionRequest: CreateCompletionRequest, options?: AxiosRequestConfig): AxiosPromise<CreateCompletionResponse>;
    createChatCompletion(createChatCompletionRequest: CreateChatCompletionRequest, options?: AxiosRequestConfig): AxiosPromise<CreateChatCompletionResponse>;
    createStreamingChatCompletion(createChatCompletionRequest: CreateChatCompletionRequest, options?: AxiosRequestConfig): AxiosPromise<CreateChatCompletionResponse>;
}
export {};
