"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenAIClient = void 0;
const utils_1 = require("./utils");
class OpenAIClient {
    constructor(openAIApi) {
        this.openAIApi = openAIApi;
    }
    performEmbedding(createEmbeddingRequest, options) {
        return (0, utils_1.retryPromise)('createChatCompletion', () => this.openAIApi.createEmbedding(createEmbeddingRequest, options), 3);
    }
    performModeration(userRequest) {
        return this.openAIApi.createModeration({ input: userRequest })
            .then(_ => _.data.results[0].flagged);
    }
    createCompletion(createCompletionRequest, options) {
        return this.openAIApi.createCompletion(createCompletionRequest, options);
    }
    createChatCompletion(createChatCompletionRequest, options) {
        return (0, utils_1.retryPromise)('createChatCompletion', () => this.openAIApi.createChatCompletion(createChatCompletionRequest, options), 3);
    }
    createStreamingChatCompletion(createChatCompletionRequest, options) {
        return (0, utils_1.retryPromise)('createStreamingChatCompletion', () => this.openAIApi.createChatCompletion(Object.assign(Object.assign({}, createChatCompletionRequest), { stream: true }), Object.assign(Object.assign({}, options), { responseType: 'stream' })), 3);
    }
}
exports.OpenAIClient = OpenAIClient;
