/// <reference types="node" />
import { Transform, TransformCallback } from "stream";
import { Logger } from "./Logger";
import { ChatCompletionChunk } from "openai/resources/chat/completions";
export interface OpenAIStreamObject {
    functionName?: string;
    chunk: string;
}
/**
 * extracts object from OpenAI lines format ("data: ...")
 *  transforms this into {OpenAIStreamObject}
 **/
export declare class OpenAIStreamChunkTransform extends Transform {
    private functionName?;
    private partialChunk;
    private logger?;
    private readonly logMetaData?;
    constructor(logger?: Logger, logMetaData?: object);
    _transform(chunk: ChatCompletionChunk, encoding: string, callback: TransformCallback): void;
}
