"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenAIStreamChunkTransform = void 0;
const stream_1 = require("stream");
/**
 * extracts object from OpenAI lines format ("data: ...")
 *  transforms this into {OpenAIStreamObject}
 **/
class OpenAIStreamChunkTransform extends stream_1.Transform {
    constructor(logger, logMetaData) {
        super({ objectMode: true });
        this.functionName = undefined;
        // sometimes a non-complete chunk of the steam comes.. we keep it here for the next drop to prepend to..
        this.partialChunk = undefined;
        this.logger = logger;
        this.logMetaData = logMetaData;
    }
    _transform(chunk, encoding, callback) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j;
        try {
            const funcName = (_c = (_b = (_a = chunk.choices[0]) === null || _a === void 0 ? void 0 : _a.delta) === null || _b === void 0 ? void 0 : _b.function_call) === null || _c === void 0 ? void 0 : _c.name;
            if (funcName) {
                this.functionName = funcName;
            }
            const content = (_f = (_e = (_d = chunk.choices[0]) === null || _d === void 0 ? void 0 : _d.delta) === null || _e === void 0 ? void 0 : _e.content) !== null && _f !== void 0 ? _f : (_j = (_h = (_g = chunk.choices[0]) === null || _g === void 0 ? void 0 : _g.delta) === null || _h === void 0 ? void 0 : _h.function_call) === null || _j === void 0 ? void 0 : _j.arguments;
            if (content) {
                this.push({
                    functionName: this.functionName,
                    chunk: content || ''
                });
            }
        }
        catch (error) {
            // sometimes OpenAI sends us only partial json..
            return callback(new Error('error processing response, please try again'));
        }
        // Call the callback to indicate that the transformation is complete
        callback();
    }
}
exports.OpenAIStreamChunkTransform = OpenAIStreamChunkTransform;
