"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpenAIStreamToStreamedHealedTransform = void 0;
const stream_1 = require("stream");
/**
 * this class transforms a stream of {OpenAIStreamObject} to {StreamedObject<T>>}
 */
class OpenAIStreamToStreamedHealedTransform extends stream_1.Transform {
    constructor(healer, logger) {
        super({ objectMode: true });
        this.logger = logger;
        this.streamStr = "";
        this.healer = healer;
    }
    _transform(chunk, encoding, callback) {
        var _a, _b;
        // Transform the data to uppercase
        const incoming = chunk;
        if (!Array.isArray(incoming)) {
            return callback(new Error(`OpenAIStreamToStreamedHealedTransform was expecting array, instead got [${Array.isArray(incoming) || typeof incoming}][${JSON.stringify(incoming)}]`));
        }
        this.streamStr += incoming.map(_ => _.chunk).join('');
        try {
            const healedStr = this.healer(this.streamStr);
            if (healedStr) {
                this.push(JSON.stringify({
                    stream: healedStr,
                }) + '\n');
            }
            callback();
        }
        catch (err) {
            if ((_a = err.message) === null || _a === void 0 ? void 0 : _a.includes('invalid end of input')) {
                // ignore while streaming...
                callback();
            }
            else {
                (_b = this.logger) === null || _b === void 0 ? void 0 : _b.error('error caught', err);
                callback(new Error('caught error:' + err.message));
            }
        }
    }
}
exports.OpenAIStreamToStreamedHealedTransform = OpenAIStreamToStreamedHealedTransform;
