/// <reference types="node" />
import { Transform, TransformCallback } from "stream";
import { ValidateFunction } from "ajv";
import { Logger } from "./Logger";
export interface StreamedObject<T> {
    stream: T;
    functionName?: string;
}
/**
 * this class transforms a stream of {OpenAIStreamObject} to {StreamedObject<T>>}
 */
export declare class OpenAIStreamToStreamedObjectTransform extends Transform {
    private typeValueAttribute;
    private validatoinValueAttribute?;
    private jsonStream;
    private readonly validateFunction;
    private readonly healPath;
    private logger?;
    private objectTypeByFunctionName?;
    constructor(validateFunction: ValidateFunction<any> | Map<string, ValidateFunction<any>>, healPath: string[] | Map<string, string[]>, logger?: Logger, typeValueAttribute?: string, validatoinValueAttribute?: string | undefined);
    _transform(chunk: any, encoding: string, callback: TransformCallback): void;
}
