"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemaValidationCache = void 0;
const ajv_1 = __importDefault(require("ajv"));
const utils_1 = require("./utils");
class SchemaValidationCache {
    constructor() {
        this.ajv = new ajv_1.default();
        this.cache = {};
    }
    getValidator(schema) {
        const schemaKey = (0, utils_1.stringToHashKey)(JSON.stringify(schema));
        if (!this.cache[schemaKey]) {
            this.cache[schemaKey] = this.ajv.compile(schema);
        }
        return this.cache[schemaKey];
    }
}
exports.SchemaValidationCache = SchemaValidationCache;
