"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StreamDebuggerTransform = void 0;
const stream_1 = require("stream");
class StreamDebuggerTransform extends stream_1.Transform {
    constructor(name, terminateStream = false, logger) {
        super({ objectMode: true });
        this.name = name;
        this.terminateStream = terminateStream;
        this.logger = logger;
    }
    _transform(chunk, encoding, callback) {
        var _a, _b;
        ((_b = (_a = this.logger) === null || _a === void 0 ? void 0 : _a.debug) !== null && _b !== void 0 ? _b : console.debug)(`[${this.name}] passing data [${JSON.stringify(chunk)}]`);
        if (!this.terminateStream) {
            this.push(chunk);
        }
        callback();
    }
}
exports.StreamDebuggerTransform = StreamDebuggerTransform;
