"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StreamMITMTransform = void 0;
const stream_1 = require("stream");
class StreamMITMTransform extends stream_1.Transform {
    constructor(transform, streamObjectSeparator = '|{-*-}|', onSuccessFinish) {
        super({ objectMode: true });
        this.transform = transform;
        this.streamObjectSeparator = streamObjectSeparator;
        this.onSuccessFinish = onSuccessFinish;
    }
    _transform(chunk, encoding, callback) {
        new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            var _a;
            try {
                const input = JSON.parse(chunk);
                const result = yield this.transform(input.stream, input.functionName);
                callback(null, JSON.stringify(result) + this.streamObjectSeparator);
            }
            catch (e) {
                if (e instanceof Error) {
                    callback(e);
                }
                else {
                    callback(new Error((_a = e === null || e === void 0 ? void 0 : e.toString()) !== null && _a !== void 0 ? _a : 'error handling transform'));
                }
            }
            finally {
                resolve();
            }
        }));
    }
    _flush(callback) {
        var _a;
        // When no more data will be added to the stream
        (_a = this.onSuccessFinish) === null || _a === void 0 ? void 0 : _a.call(this);
        callback();
    }
}
exports.StreamMITMTransform = StreamMITMTransform;
