/// <reference types="node" />
import { Transform, TransformCallback } from "stream";
import { Logger } from "./Logger";
export type ThrottledTransformOptions = {
    name: string;
    windowSize: number;
    flushDebounceTimeMs: number;
    maxIdleTimeoutMs: number;
};
export type WriteTo = <T>(itemsOrError: T[] | Error) => Promise<void>;
export declare class ThrottledTransform<T> extends Transform {
    private queue;
    private options;
    private flushDebounceTimer;
    private maxTimeoutTimer;
    private writeTo?;
    private logger?;
    constructor(options: ThrottledTransformOptions, logger?: Logger, writeTo?: WriteTo);
    _transform(chunk: T, encoding: string, callback: TransformCallback): void;
    _flush(callback: Function): void;
    private cleanMaxTimeout;
    private cleanDebounceTimer;
    private flushQueue;
    _final(callback: (error?: (Error | null)) => void): void;
    getQueueSize: () => number;
}
